



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL Server排名或排序的函数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL Server排名或排序的函数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 09:44:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>SQL Server获得排名或排序的函数有如下几种：</div>
<div>1、Rank()：在结果集中每一条记录所在的排名位置，但排名可能不连续，例如：若同一组内有两个第一名，则该组内下一个名次直接跳至第三名</div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums"> select *,Rank() over (partition by modifieddate order by locationid ) as Rank from Production.ProductInventory&nbsp;</pre>
</div>
<p>2、Dense_Rank()：功能与Rank相似，但排名的数值是连续的，例如：若同一组内有两个第一名，则该组内下一个名次为第二名</p>
<div>
<pre class="prettyprint linenums">select *,dense_Rank() over (partition by modifieddate order by locationid ) as Rank from Production.ProductInventory </pre>
</div>
<p>3、Row_Number()：根据组显示每一条记录在该组中出现的位置，例如：若有两个第一名，则这两个第一名在一组内排名为1、2，下一组的排序仍从1开始，依次类推</p>
<div>
<pre class="prettyprint linenums">select *,row_number() over (partition by productid  order by productid ) as Rank from Production.ProductInventory </pre>
</div>
<p>4、NTILE()：根据指定的分组数量将结果集分区，并记录其在组中的位置。可以对结果集的数据排序后，按照指定的数量把结果集分成N组，并给予每组一个组编号，分组的方式很简单，将结果集的总记录数除以N，若有余数M，则前M组都多增一条记录，因此，并非所有的组都有相同的记录数，但多记录的组最多只有一条记录。</p>
<div>
<pre class="prettyprint linenums">select top 13 *,NTILE(2) over (partition by productid  order by locationid ) as Rank from Production.ProductInventory </pre>
</div>
<p>上述四个函数语法格式相同，都要搭配OVER子句，而且要以指定切分或排序记录的方式，OVER子句定议格式如下：<br />Over（【Partition BY &lt;提供数值的描述方式&gt;】 ORDER BY &lt;字段&gt; [DES|ASC]）<br />Partition BY 子句决定排名记录的分组方式，而Order By 子句决定每一组记录要如何排序，如果省略了Partition by 子句，则全部记录为一组</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4950my68.html">&lbrack;2013-08-01&rsqb;window&period;open</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqver5x9.html">mysqldump&colon; Error&colon; Binlogging on server not active</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1w6y09.html">easyui datagrid 分页略解</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gxo3eq.html">node基础05：路由基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/390lez49.html">控制浏览器高度 宽度 只能支持ie</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwp7k38.html">Js中的window&period;parent &comma;window&period;top&comma;window&period;self 详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m0ykr9.html">Android gradle问题解决&colon; This app has been built with an incorrect configuration&period; Please configure your build for VectorDrawableCompat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn114yx8.html">Open-falon监控安装过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnk57oq.html">php7&period;0 redis扩展下载地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjo0gz9.html">Javascript数组方法探究一二</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mng2xoq.html">实现在Android 多点手势识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxknrvv8.html">How to use STA（sql tuning advisor）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950povz8.html">MFC乱七八糟笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2je2x38.html">C&sol;C&plus;&plus;生成随机数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkj02e8.html">半径无关快速高斯模糊实现&lpar;附完整C代码&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxvvzq.html">DevExpress 控件汉化代码和使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwj6r48.html">Ansible 安装与配置&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvndzg8.html">电脑端支付宝支付 -前端获取支付宝返回的form 以及submit 调用支付扫码页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2we56q.html">C&num; 动态调用WebService 2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q257rolq.html">SQLTest系列之INSERT语句测试</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jz4w5l8.html">Tiny4412之重力感应器驱动</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgro0m8.html">SSM-Spring-07：Spring基于注解的di注入</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk3n308.html">python之&commat;property</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjxjjg8.html">学会这15点，让你分分钟拿下Redis数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg2g078.html">Python中的r&plus;和a&plus;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1715dq.html">switch窗口句柄</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jzj4x8.html">在Windows Server 2008 R2下搭建jsp环境（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk3d3v8.html">我TM菜爆</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyg53m9.html">JDBC知识详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpen6j9.html">循环神经（LSTM）网络学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
